const char osd_schema[] =
"--\n"
"-- schema for OSD using sqlite3\n"
"--\n"
"-- Copyright (C) 2007 OSD Team <pvfs-osd@osc.edu>\n"
"--\n"
"-- This program is free software: you can redistribute it and/or modify\n"
"-- it under the terms of the GNU General Public License as published by\n"
"-- the Free Software Foundation, version 2 of the License.\n"
"-- \n"
"-- This program is distributed in the hope that it will be useful,\n"
"-- but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
"-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"
"-- GNU General Public License for more details.\n"
"-- \n"
"-- You should have received a copy of the GNU General Public License\n"
"-- along with this program.  If not, see <http://www.gnu.org/licenses/>.\n"
"--\n"
"\n"
"-- 4.6.2: The combination of partition ID and user object ID uniquely\n"
"-- identifies the root obect, each partition, each collection, and each\n"
"-- user object.  Thus we store everything in this one table.\n"
"CREATE TABLE obj (\n"
"	pid INTEGER NOT NULL,\n"
"	oid INTEGER NOT NULL,\n"
"	type INTEGER NOT NULL,\n"
"	PRIMARY KEY (pid, oid)\n"
");\n"
"\n"
"CREATE TABLE attr (\n"
"	pid INTEGER NOT NULL,\n"
"	oid INTEGER NOT NULL,\n"
"	page INTEGER NOT NULL,\n"
"	number INTEGER NOT NULL,\n"
"	value BLOB,\n"
"	PRIMARY KEY (pid, oid, page, number)\n"
");\n"
"\n"
"-- object_collection table is used as an intersection table to hold\n"
"-- many-to-many mappings between userobjects and collections.\n"
"-- The conflict condition handles the point mentioned in 7.1.2.19\n"
"-- osd2r02.pdf:\n"
"\n"
"--   If the collection type attribute in the Collection Information attributes\n"
"--   page contains 00h, a user object is removed from the membership of a\n"
"--   collection by:\n"
"--     a) Changing the collection pointer attribute identifying that\n"
"--     collection to have a length of zero; or \n"
"--     b) Setting the collection pointer attribute identifying that \n"
"--     collection to the Collection_Object_ID of a different collection.\n"
"\n"
"\n"
"\n"
"CREATE TABLE coll (\n"
"	pid INTEGER NOT NULL,\n"
"	cid INTEGER NOT NULL,\n"
"	oid INTEGER NOT NULL,\n"
"	number INTEGER NOT NULL,\n"
"	PRIMARY KEY (pid, cid, oid),\n"
"	UNIQUE (pid, oid, number) ON CONFLICT REPLACE\n"
");\n"
"\n"
"-- Add index on most varying fields for performance\n"
"-- CREATE INDEX obj_ind ON obj (pid,oid);\n"
"-- CREATE INDEX attr_ind ON attr (pid,oid,page,number);\n"
"-- CREATE INDEX pgnum_ind ON attr (page,number);\n"
"-- CREATE INDEX type_ind ON obj (type);\n"
"\n"
"-- index on value helps OSD_QUERY \n"
"CREATE INDEX val_ind ON attr (value);\n"
"\n"
"-- this index help get_dir_page query, but might slow down set_attr\n"
"-- CREATE INDEX num_ind ON attr (pid,oid,number);\n"
"\n"
;
